/* Terraform - (C) 1997_1999 Robert Gasch (Robert_Gasch@peoplesoft.com)
 *  - www.peoplesoft.com/peoplepages/g/robert_gasch/terraform/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111_1307, USA.
 */


#ifndef _TF_DIALOG_OPTIONS_H
#define _TF_DIALOG_OPTIONS_H


#include "flexarray.h"
#include "GuiDialogOAC.h"				// includes gtk, gtk--



/*
 *  TFDialogOptions: display the options dialog for terraform. This is a 
 * 	global dialog!
 */
class TFDialogOptions : public GuiDialogOAC
	{
	public:	
				TFDialogOptions (FlexArray *wList);
				~TFDialogOptions ();
		void		updateSliders ();
		void		buildDialogWindow ();
		void 		buttonCallbackOK ();
		void 		buttonCallbackApply ();
		gint 		delete_event_impl (GdkEventAny *);

	protected:
		void		buildDrawOptionsFrame ();
		void		buildHFDrawOptionsFrame ();
		void		buildFastWireOptionsFrame ();
		void		buildPOVOptionsFrame ();

	private:
		void		fillVBox ();
		void		getValues (bool *fillSea, bool *drawDerived, 
					int *scale, int *syncRate, 
					int *resolution, float *yscale, 
					float *sealevel, bool *fastHalfRes, 
					bool *fastHalfYscale, bool *fastZrot);

		// had to make alloc of HBox and VBox dynamic to avoid running
		// into the huge-objects warning with egcs
		FlexArray		*d_wList;
		Gtk_Notebook		d_notebook;	
		Gtk_Frame 		d_frame1, d_frame2, d_frame3, d_frame4;
		Gtk_OptionMenu		d_colormapOptMenu;
		Gtk_Menu		d_colormapMenu;
		Gtk_Entry		d_enPOVfile;
		Gtk_CheckButton		d_cbFillSea,
					d_cbDrawDerived,
					d_cbFastResolution,
					d_cbFastYscale,
					d_cbFastZrot,
					d_cbPOVhalfYscale,
					d_cbPOVkeepFiles;
		Gtk_VBox		*d_vBox1, *d_vBox2, *d_vBox3, *d_vBox4;
		Gtk_HBox		*d_hBox1_1, *d_hBox1_2, *d_hBox1_3, *d_hBox1_4,
					*d_hBox2_1, *d_hBox2_2, *d_hBox2_3,
					*d_hBox3_1, *d_hBox3_2, *d_hBox3_3,
					*d_hBox4_1, *d_hBox4_2, *d_hBox4_3, *d_hBox4_4;
		Gtk_Label 		*d_lblTitle1, *d_lblTitle2, 
					*d_lblTitle3, *d_lblTitle4,
					*d_lblScale, *d_lblSync,
					*d_lblResolution, *d_lblYScale, *d_lblSealevel,
					*d_lblFillSea, *d_lblDrawDerived, 
					*d_lblFastResolution, 
					*d_lblFastYscale, *d_lblFastZrot, 
					*d_lblPOVfileName, *d_lblPOVwidth, 
					*d_lblPOVyscale, *d_lblPOVkeepFiles;
		Gtk_Adjustment	*d_adjScale, *d_adjSync,
					*d_adjResolution, *d_adjYScale, *d_adjSealevel,
					*d_adjPOVwidth;
		Gtk_HScale		*d_hsScale, *d_hsSync,
					*d_hsResolution, *d_hsYScale, *d_hsSealevel,
					*d_hsPOVwidth; 
	};

#endif // _TF_DIALOG_OPTIONS_H
